<? 

// Funktion: I18n hinzufügen
add_action( 'init', 'ng_gallery_geo_lang' );
function ng_gallery_geo_lang() 	{load_plugin_textdomain( 'nextgen-gallery-geo', false, 'nextgen-gallery-geo/lang' );}

// Funktion: Karte anzeigen

function ng_gallery_geo_show($map_width = NULL, $map_height = NULL, $zoom_level = NULL, $gallery_id = NULL)
{
	echo ng_gallery_geo($map_width, $map_height, $zoom_level, $gallery_id);
}


// Funktion: Headerdaten ausgeben
function ng_gallery_geo_header() 
{
echo 		'<!-- NextGen Gallery geo plugin -->
			<script type="text/javascript" src="http://ecn.dev.virtualearth.net/mapcontrol/mapcontrol.ashx?v=7.0"></script>
			<script charset="UTF-8" type="text/javascript" src="http://ecn.dev.virtualearth.net/mapcontrol/mapcontrol.ashx?v=6.3&mkt='.get_bloginfo ("language").'"></script>
			<style type="text/css">
			.ngg_geo_map {width: '.get_option('ngg_geo_map_width').'; height: '.get_option('ngg_geo_map_height').'; position:relative;}
			</style>
			
			<!-- / NextGen Gallery geo plugin -->';
}
		
// Funktion: Koordinatenberechnung
function ng_gallery_geo_coordinates($picture_path)
{
	// Auslesen der Koordinaten
	$exif = exif_read_data($picture_path, 0 , false);
	
		// Es muss erst geprüft werden, ob überhaupt GPS Daten fuer das Bild gespeichert sind.
		
			if (!isset ($exif[GPSLongitude][0])) {return false;}
			
			
			// Berechnung der Längenangaben
			
			// einmal.
			$gps_laenge_1 = explode("/",$exif[GPSLongitude][0]);
			if (isset($gps_laenge_1[1])) {$gps_laenge_1 = ($gps_laenge_1[0] / $gps_laenge_1[1]);} else {$gps_laenge_1 = $gps_laenge_1[0] ;}
			
			// zweimal.
			$gps_laenge_2 = explode("/",$exif[GPSLongitude][1]);
			if (isset($gps_laenge_2[1])) {$gps_laenge_2 = ($gps_laenge_2[0] / $gps_laenge_2[1]);} else {$gps_laenge_2 = $gps_laenge_2[0] ;}
			
			// dreimal... hier mit Runden und Auffuellen der Nullen
			$gps_laenge_3 = explode("/",$exif[GPSLongitude][2]);
			if (isset($gps_laenge_3[1])) {$gps_laenge_3 = ($gps_laenge_3[0] / $gps_laenge_3[1]);} else {$gps_laenge_3 = $gps_laenge_3[0] ;}
			$gps_laenge_3 = round ($gps_laenge_3, 2);
			$gps_laenge_3 = str_pad($gps_laenge_3, 5 ,'0', STR_PAD_RIGHT);
			
			$gps_laenge = ($gps_laenge_1)."&deg;".($gps_laenge_2)."&#x27;".($gps_laenge_3).'&#x22;';
			
			
			// Berechnung der Breitenangaben
			
			// einmal.
			$gps_breite_1 = explode("/",$exif[GPSLatitude][0]);
			if (isset($gps_breite_1[1])) {$gps_breite_1 = ($gps_breite_1[0] / $gps_breite_1[1]);} else {$gps_breite_1 = $gps_breite_1[0] ;}
			
			// zweimal.
			$gps_breite_2 = explode("/",$exif[GPSLatitude][1]);
			if (isset($gps_breite_2[1])) {$gps_breite_2 = ($gps_breite_2[0] / $gps_breite_2[1]);} else {$gps_breite_2 = $gps_breite_2[0] ;}
			
			// dreimal... hier mit Runden und Auffuellen der Nullen
			$gps_breite_3 = explode("/",$exif[GPSLatitude][2]);
			if (isset($gps_breite_3[1])) {$gps_breite_3 = ($gps_breite_3[0] / $gps_breite_3[1]);} else {$gps_breite_3 = $gps_breite_3[0] ;}
			$gps_breite_3 = round ($gps_breite_3, 2);
			$gps_breite_3 = str_pad($gps_breite_3, 5 ,'0', STR_PAD_RIGHT);
			
			$gps_breite = ($gps_breite_1)."&deg;".($gps_breite_2)."&#x27;".($gps_breite_3).'&#x22;';
			
			// Umrechung in das Gradformat
			$gps_laenge_format = $gps_laenge;
			$gps_breite_format = $gps_breite;
			$gps_laenge = (((($gps_laenge_3 / 60) + $gps_laenge_2) / 60) + $gps_laenge_1);
			$gps_breite = (((($gps_breite_3 / 60) + $gps_breite_2) / 60) + $gps_breite_1);
			
			// Unterscheidung in Nord und Sued und West und Ost.
			if ($exif[GPSLatitudeRef] == "S") {$gps_breite = "-$gps_breite"; $gps_breite_format = "S $gps_breite_format";} else {$gps_breite_format = "N $gps_breite_format";}
			if ($exif[GPSLongitudeRef] == "W") {$gps_laenge = "-$gps_laenge"; $gps_laenge_format = "W $gps_laenge_format";} else {$gps_laenge_format = "O $gps_laenge_format";}
			
			$ng_gallery_geo_coordinates = array("gps_laenge" => $gps_laenge, "gps_breite" => $gps_breite, "gps_laenge_format" => $gps_laenge_format, "gps_breite_format" => $gps_breite_format);
			return $ng_gallery_geo_coordinates;
		
}
			
			
// Funktion: Geocode
			function ngg_geo_geocode ($adresse)
			{
				/// Diese Funktion ermittelt aus einem Text nach Möglichkeit Koordinaten. Dabei können verschiedene Provider verwendet werden. 
				/// Die Wahl des Providers kann in den Einstellungen getroffen werden.
				
				$provider = get_option('ngg_geo_geocoding_provider');
				
				if ($provider == "google_v2")
				{
							$geo = file('http://maps.google.com/maps/geo?q='.rawurlencode("$adresse").'&output=csv');
							$response = split(",", $geo[0]);
							if ($response[0] == 200){
							$coordinates = $response[2].",".$response[3];
			
							// zu ungenau!
							if ($response[1] < 2) {$coordinates = "error";}
			
							}else{
							// Fehler
							$coordinates = "error";
							}
							
						 	return $coordinates;
				}
				
				if ($provider == ('google_v3'))
				
				{
							$jsonfile = file_get_contents('http://maps.google.com/maps/api/geocode/json?address='.rawurlencode($adresse).'&sensor=true');
							$jsonarray = json_decode($jsonfile, TRUE);
							
							// Fehler: keine Koordinaten
							if  ($jsonarray["status"] == "INVALID_REQUEST" or $jsonarray["status"] == "ZERO_RESULTS" ) {$coordinates = "error"; return $coordinates;}	
							
							$coordinates = $jsonarray["results"][0]["geometry"]["location"]["lat"].",".$jsonarray["results"][0]["geometry"]["location"]["lng"];
							return $coordinates;
				}
				
				if ($provider == ('openstreetmaps'))
				
				{
							$jsonfile = file_get_contents('http://nominatim.openstreetmap.org/search/?format=json&addressdetails=1&limit=1&q='.rawurlencode($adresse));
							// Fehler: keine Koordinaten
							if (!json_decode($jsonfile, TRUE)) {$coordinates = "error"; return $coordinates;}
							
							$jsonarray = json_decode($jsonfile, TRUE);
							$coordinates = $jsonarray[0][lat].','.$jsonarray[0][lon];
							return $coordinates;
				}
				
				if ($provider == ('yahoo'))
				
				{
							$jsonfile = file_get_contents('http://where.yahooapis.com/geocode?appid='.get_option('ngg_geo_geocoding_key').'&count=1&flags=JC&q='.rawurlencode($adresse));
							$jsonarray = json_decode($jsonfile, TRUE);
							
							// Fehler: keine Koordinaten
							if ($jsonarray[ResultSet][Found] == 0) {$coordinates = "error"; return $coordinates;}
							
							$coordinates = $jsonarray[ResultSet][Results][0][latitude].','.$jsonarray[ResultSet][Results][0][longitude];
							return $coordinates;
				}
			}
			

//Funktion: Auslesen der Gallerie-ID aus dem aktuellen Artikel
function ngg_geo_get_id ()
{	
		// Der Post wird ausgelesen
		$text = get_the_content();
		
		// Aus dem Posttext wird die Galerie-ID ausgelesen
		if(strpos($text,"[nggallery id=")!==false) 
							{
										$first = strpos ( $text, '[nggallery id=' );
										$position = (14 + $first);
							}
						else
							{
								if(strpos($text,"[gallery=")!==false)
												  {
														$first = strpos ( $text, '[gallery=' );
														$position = (9 + $first);
												  }
												else
												{
												return false;	
												}
							}
		
		
		
		
		$gallery_id = $text[$position];
		
		// Wie lang ist die Zahl der Galerie-ID?
		if (is_numeric($text[($position + 1)])) {$gallery_id = $text[$position].$text[($position + 1)];
		if (is_numeric($text[($position + 2)])) {$gallery_id = $text[$position].$text[($position + 1)].$text[($position + 2)];
		if (is_numeric($text[($position + 3)])) {$gallery_id = $text[$position].$text[($position + 1)].$text[($position + 2)].$text[($position + 3)];}}}
		return $gallery_id;
}

//Funktion: Beim Editieren eines Artikels darf die Karte natürlich nicht eingeblendet werden

function ng_gallery_geo_no() {static $ng_gallery_geo_no = 1;}

add_action('edit_post', 'ng_gallery_geo_no');
add_action('wp_print_scripts', 'ng_gallery_geo_header');

// Funktion: Wenn eine Galerie eingebunden wird, wird versucht eine Karte zu erstellen
	
if (get_option('ngg_geo_auto') == 1) 	{add_filter('ngg_gallery_output', 'ng_gallery_geo_include', 10, 2);}
		
// Funktion: Alternativ kann die Karte auch nur für den Fall angezeigt werden, dass sie im Text eingebunden wird (durch [nggg])

function ng_gallery_geo_auto_tag($content)

	{
		if (strpos($content, "[nggg]")!== false)
			{
				$content  = str_replace('[nggg]', ng_gallery_geo(), $content);
			}

		return $content;		
	}

if (get_option('ngg_geo_auto') == 2) 	{add_filter('the_content', 'ng_gallery_geo_auto_tag');	}
