<?php

/*
Plugin Name: NextGEN Gallery geo
Plugin URI: http://denktfrei.de/
Description: nextgen-gallery geo zeigt eine Karte mit allen Fotos aus einer Gallerie an.
Version: 0.41
Author: Frederic Stuhldreier
Author URI: http://www.frest.de/
*/

include "administration.php";
include "functions.php";
include "worldmap.php";
include "include_map.php";


// $zoom_level ist die Zoomstufe. Diese kommt nur zum Einsatz, wenn keine Geodaten vorhanden sind. Auerdem knnen Informationen wie Kartenbreite und Hhe angegeben werden.

function ng_gallery_geo($map_width = NULL, $map_height = NULL, $zoom_level = NULL, $gallery_id = NULL){ 

// Die Karte darf auf bestimmten Seiten nicht eingeblendet werden
if (isset($ng_gallery_geo_no)) {if ($ng_gallery_geo_no == 1) {return false;}}

// Wurden style Parameter (Hhe, Breite der Karte) bergeben? Falls ja, werden diese in den Container eingbaut, und dafr nun zusammengefgt
if  ((is_numeric($map_width[0])) OR (is_numeric($map_height[0])))
 {
	$ngg_geo_map_style .= 'style = "';
	if  (is_numeric($map_width[0])) {$ngg_geo_map_style .= 'width:'.$map_width.';';}
	if  (is_numeric($map_height[0])) {$ngg_geo_map_style .= 'height:'.$map_height.';';}
	$ngg_geo_map_style .= '"';
 }
 
// Wurde ein Zoom-Level bergeben? Falls nein, werden die Einstellungen abgerufen
if (is_numeric ($zoom_level)) {$ngg_geo_map_zoomlevel = $zoom_level;} else {$ngg_geo_map_zoomlevel = get_option('ngg_geo_zoom_level');}


// Die Galerie ID wird aus dem aktuellen Post ausgelesen, falls keine Gallerie-ID ber die Funktion bergeben wurde. Falls keine ID ausgelesen werden kann, wird das Plugin beendet
if (!is_numeric ($gallery_id)) {$gallery_id = ngg_geo_get_id (); if ($gallery_id == false) {return;}}

// Die Variable $ngg_geo_pass zhlt mit, wie oft das script durchlaufen wurde. Damit werden spter die Karten nummeriert
if (!isset ($ngg_geo_pass)) {static $ngg_geo_pass = 1;}

// Einbinden der Wordpress Datenbank-Klasse
global $wpdb;

// Der Datenbank-Prefix wird ausgelesen und die Tabellennamen gespeichert
$wpdb->ngg_gallery = $wpdb->prefix."ngg_gallery";
$wpdb->ngg_pictures = $wpdb->prefix."ngg_pictures";

// SQL: Die Informationen der Galerie werden abgerufen
$new_gallery_data = $wpdb->get_results( "SELECT title, path, previewpic, galdesc FROM $wpdb->ngg_gallery WHERE gid = $gallery_id;", ARRAY_A );

$gallery_title = $new_gallery_data[0]['title']; 
$gallery_path = $new_gallery_data[0]['path']; 
$gallery_previewpic = $new_gallery_data[0]['previewpic']; 
$gallery_galdesc = $new_gallery_data[0]['galdesc']; 

// SQL: Die Dateinamen der Bilder der jeweiligen Galerie werden ausgelesen, damit der komplette Pfad gebildet werden kann.
$gallery_filenames = $wpdb->get_results( "SELECT filename FROM $wpdb->ngg_pictures WHERE `galleryid` = $gallery_id;", ARRAY_A );


// Wie viele Bilder gibt es berhaupt in der Datenbank zugehrig zur jeweiligen Galerie?
$anzahl_bilder = count($gallery_filenames);
$control = 0;

// Zum Auslesen der Infos geht die Schleife los.

while ($control < $anzahl_bilder)
{
	
$picture = $gallery_filenames[$control]["filename"];
$picture_path = $gallery_path."/".$gallery_filenames[$control]["filename"];
$picture_thumbs_path = $gallery_path."/thumbs/thumbs_".$gallery_filenames[$control]["filename"];
$picture_thumbs_url = get_bloginfo(wpurl)."/".$gallery_path."/thumbs/thumbs_".$gallery_filenames[$control]["filename"];

// Scheinbar gibt es Probleme, wenn Bilder mit Photoshop bearbeitet wurden. Es wird dann eine Warnung ausgegeben, diese stellt man besser aus.
error_reporting(0);

// Es muss erst geprft werden, ob berhaupt GPS Daten fuer das Bild gespeichert sind, die Daten werden abgerufen
if ($coordinates = ng_gallery_geo_coordinates($picture_path)) 
{
	

// Die Bildbeschreibung wird abgerufen
$picture_description = $wpdb->get_var( " SELECT description FROM $wpdb->ngg_pictures WHERE filename = '$picture' AND galleryid = '$gallery_id' ");						


// Verpackt ist es nun. Jetzt folgt die Ausgabe in die Karte.
// $control_1 wird genutzt, um die Bilder sinnvoll zu nummerieren. $control_1 kann auerdem genutzt werden, um festzustellen, welche Fotos der Galerie ber Geo-Informationen verfgen bzw. auf der Karte angezeigt werden. Dazu wird die Variable wieder um eins verringert
$control_1 = ($control + 1);


// Falls die Schleife zum ersten Mal durchluft, muss erst die Karte erstellt werden und der div Container eingefgt werden
		if (!isset($ngg_geo_init))
		{
			$ngg_geo_init = 1;
			$ngg_geo_return = '<div id="ngg_geo_map_'.$ngg_geo_pass.'" class="ngg_geo_map" '.$ngg_geo_map_style.'></div>
			<script type="text/javascript">
					 var map = null;
					 
					 function nggGeoMap()
					 {
						map_'.$ngg_geo_pass.' = new VEMap("ngg_geo_map_'.$ngg_geo_pass.'");
						map_'.$ngg_geo_pass.'.SetCredentials("Your Bing Maps Key");
						map_'.$ngg_geo_pass.'.HideDashboard();
						map_'.$ngg_geo_pass.'.LoadMap();
						map_'.$ngg_geo_pass.'.SetMapStyle(VEMapStyle.'.get_option("ngg_geo_map_type").');
						var locs = [];
			';	
		}


					// Die Pin-Beschreibung wird zusammengebaut: Ist eine Bildbeschreibung vorhanden? Falls nicht, wird die Nummer und die Galerie angegeben
					if ((strlen($picture_data->description)) > 1) {$pin_description = '<b>'.$picture_data->description.'</b><br><br><img src="'.$picture_thumbs_path.'" alt="foto" /><br><br>'.__('GPS coordinates', 'nextgen-gallery-geo').' <br> '.__('latitude:', 'nextgen-gallery-geo').' '.$coordinates[gps_breite_format].'<br> '.__('longitude:', 'nextgen-gallery-geo').' '.$coordinates[gps_laenge_format].'';}
					else {$pin_description = sprintf(__('<b>Photo Nr. %1$s of gallery %2$s</b><br><br><img src="%3$s" alt="foto" /><br><br>GPS coordinates <br> Latitude: %4$s<br> Longitude: %5$s', 'nextgen-gallery-geo'), $control_1, $gallery_title, $picture_thumbs_path, $coordinates[gps_breite_format], $coordinates[gps_laenge_format]);  ;}

// $ngg_geo_map_pins zhlt mit, wie viele pins gesetzt wurden. Dies dient u.a. zur sinnvollen Benennung
if (!isset ($ngg_geo_map_pins)) {$ngg_geo_map_pins = 0;}
$ngg_geo_map_pins++;


// Die eigentliche Schleife beginnt
$ngg_geo_return .= 

			'var loc_'.$ngg_geo_map_pins.' = new VELatLong('.$coordinates[gps_breite].','.$coordinates[gps_laenge].');
			var pin_'.$ngg_geo_map_pins.' = new VEPushpin('.$ngg_geo_map_pins.', loc_'.$ngg_geo_map_pins.', "wp-content/plugins/nextgen-gallery-geo/thumbnail.php?src='.urlencode($picture_thumbs_url).'&p=40", "'.$gallery_title.'", \''.$pin_description.'\');            
			map_'.$ngg_geo_pass.'.AddPushpin(pin_'.$ngg_geo_map_pins.');
			locs.push(loc_'.$ngg_geo_map_pins.');';


// Es gibt also Punkte auf der Karte. Also kann das Ganze angezeigt werden.
$on = 2;

}

$control++;
 
}

// Die Karte wird geschlossen, der Fokus gesetzt und die Karte eingebunden
if ($on == 2) {
				
					/// Soll eine Reiseroute dargestellt werden? Falls ja, wird entsprechend eine Linie eingeblendet
					if (get_option('ngg_geo_map_route') == 1) {$ngg_geo_return .= 'var routeColor = new VEColor(0,0,255,.2); var poly = new VEPolyline(12, locs, routeColor, 5); map_'.$ngg_geo_pass.'.AddPolyline(poly);';}
					
					// Ist mehr als ein pin vorhanden? Falls ja, erfolgt die Fokussierung automatisch. Andernfalls wird auf den einzigen pin fokussiert, und ein definiertes zoomlevel verwendet
					if ($ngg_geo_map_pins == 1) 
						{$ngg_geo_return .= 'map_'.$ngg_geo_pass.'.SetCenterAndZoom(loc_1, '.$ngg_geo_map_zoomlevel.')';
												// Soll Birdseyeview eingebunden werden, falls vorhanden?
												if  (get_option('ngg_geo_map_bev') == 1) 
												{
													$ngg_geo_return .= 
													'
													map_'.$ngg_geo_pass.'.AttachEvent("onobliqueenter", OnObliqueEnterHandler_'.$ngg_geo_pass.');
														  function OnObliqueEnterHandler_'.$ngg_geo_pass.'()
																{	if (map_'.$ngg_geo_pass.'.IsBirdseyeAvailable())
																	{  map_'.$ngg_geo_pass.'.SetMapStyle(VEMapStyle.Birdseye);
																	 map_'.$ngg_geo_pass.'.DetachEvent("onobliqueenter", OnObliqueEnterHandler_'.$ngg_geo_pass.');	}
																}
																';
												}
						}
					else {$ngg_geo_return .= 'map_'.$ngg_geo_pass.'.SetMapView(locs);';}
					
					// Die Karte wird geschlossen und aufgerufen
				  	$ngg_geo_return .= '} </script><script type="text/javascript"> nggGeoMap(); </script>';
			 }



###########################################################
##### Keine Geodaten vorhanden, geocoding (falls erwnscht)
###########################################################


if (!isset ($on) and get_option('ngg_geo_geocoding_provider') != "no")
{
	// Galeriename in Geocode umwandeln
	$ngg_geo_geocode_data = ngg_geo_geocode($gallery_title);
	
		if ($ngg_geo_geocode_data != "error")
	{
		$control = 1;
	
// SQL: Ist ein Vorschaubild vorhanden? Falls ja, wird dieses als Icon verwendet. Falls nein, wird das letzte Bild als Icon verwendet.
if ($gallery_previewpic == 0)	{ 
										$map_previewpic_path = get_bloginfo(wpurl)."/".$gallery_path."/thumbs/thumbs_".$picture;
									}
									
else 								{
										$new_picture_previewpic_filename = $wpdb->get_var( "SELECT filename FROM $wpdb->ngg_pictures WHERE pid = $gallery_previewpic");
										$map_previewpic_path = get_bloginfo(wpurl)."/".$gallery_path."/thumbs/thumbs_".$new_picture_previewpic_filename;
									}
							

	
	// Ist eine Galeriebeschreibung vorhanden? Falls ja, wird diese ausgegeben.
	if ($gallery_galdesc != "") {
				$map_description = "<b>".$gallery_galdesc."</b><br><br><img src=\"".$map_previewpic_path."\" alt=\"foto\" />";
				// Vorher muessen noch alle Zeilenumbrueche entfrent werden
				$map_description = preg_replace("/\r|\n/s", "", $map_description);
	}
	else {$map_description = sprintf(__('<b>Photo of gallery "%1$s" </b><br><br><img src="%2$s" alt="photo" />', 'nextgen-gallery-geo'), $gallery_title, $map_previewpic_path);}
	


$ngg_geo_return = '<div id="ngg_geo_map_'.$ngg_geo_pass.'" class="ngg_geo_map" '.$ngg_geo_map_style.'></div>';
$ngg_geo_return .=
'
   <script type="text/javascript">
         var map_'.$ngg_geo_pass.' = null;
         
         function nggGeoMap()
         {
            map_'.$ngg_geo_pass.' = new VEMap("ngg_geo_map_'.$ngg_geo_pass.'");
            map_'.$ngg_geo_pass.'.SetCredentials("Your Bing Maps Key");
   			map_'.$ngg_geo_pass.'.HideDashboard();
			map_'.$ngg_geo_pass.'.LoadMap();
			var x = new VELatLong('.$ngg_geo_geocode_data.');
			map_'.$ngg_geo_pass.'.SetCenterAndZoom(x, '.$ngg_geo_map_zoomlevel.');
			map_'.$ngg_geo_pass.'.SetMapStyle(VEMapStyle.'.get_option("ngg_geo_map_type").');
						
			var pin = new VEPushpin(1, map_'.$ngg_geo_pass.'.GetCenter(), "'.$map_previewpic_path.'", "'.$gallery_title.'", \''.$map_description.'\');            
			map_'.$ngg_geo_pass.'.AddPushpin(pin);';
			

					// Soll Birdseyeview eingebunden werden, falls vorhanden?
			        if  (get_option('ngg_geo_map_bev') == 1) 
					{
						$ngg_geo_return .= 
						'
		 				map_'.$ngg_geo_pass.'.AttachEvent("onobliqueenter", OnObliqueEnterHandler_'.$ngg_geo_pass.');
		        			  function OnObliqueEnterHandler_'.$ngg_geo_pass.'()
								 	{	if (map_'.$ngg_geo_pass.'.IsBirdseyeAvailable())
										{  map_'.$ngg_geo_pass.'.SetMapStyle(VEMapStyle.Birdseye);
							  			 map_'.$ngg_geo_pass.'.DetachEvent("onobliqueenter", OnObliqueEnterHandler_'.$ngg_geo_pass.');	}
									}
									';
					}
					
					
$ngg_geo_return .=
'}
nggGeoMap();
</script>';


		$on = 1;

		
	}
	
}

// Fehlermeldung: Es konnte keine Karte erstellt werden. Diese Meldung kann deaktiviert werden
if (!isset ($on) && get_option('ngg_geo_error') == 1) {_e('error: unable to generate map', 'nextgen-gallery-geo');}


// Der Durchlaufszhler wird als statische Variable erhoeht, damit die Karten sinnvoll benannt werden koennen
$ngg_geo_pass++;

return $ngg_geo_return;
}


?>