<?

// Funktion: Welt Karte mit allen Gallerien anzeigen
function ngg_geo_worldmap($map_width, $map_height)
{
	
// Wurden style Parameter (Höhe, Breite der Karte) übergeben? Falls ja, werden diese in den Container eingbaut, und dafür nun zusammengefügt
if  ((is_numeric($map_width[0])) OR (is_numeric($map_height[0])))
 {
	$ngg_geo_map_style .= 'style = "';
	if  (is_numeric($map_width[0])) {$ngg_geo_map_style .= 'width:'.$map_width.';';}
	if  (is_numeric($map_height[0])) {$ngg_geo_map_style .= 'height:'.$map_height.';';}
	$ngg_geo_map_style .= '"';
 }
	
// Einbinden der Wordpress Datenbank-Klasse
global $wpdb;

// Der Datenbank-Prefix wird ausgelesen und die Tabellennamen gespeichert
$wpdb->ngg_gallery = $wpdb->prefix."ngg_gallery";
$wpdb->ngg_pictures = $wpdb->prefix."ngg_pictures";

// SQL: Die Informationen der Galerie werden abgerufen

$worldmap_data = $wpdb->get_results( 
"SELECT path, filename, title, galdesc, gid
FROM $wpdb->ngg_pictures, $wpdb->ngg_gallery
WHERE $wpdb->ngg_pictures.pid = $wpdb->ngg_gallery.previewpic", ARRAY_A );

// Es folgt eine Schleife, in der geprüft wird, ob für die Vorschaubilder Koordinaten vorliegen.


foreach ($worldmap_data as $data) 
{
	// Der Dateipfad des Vorschaubildes wird gebildet
	$picture_path = $data[path]."/".$data[filename];
	
	// Die Exif-Information werden ausgelesen
	$exif = exif_read_data($picture_path, 0 , false);
	
	// Es sind Exif Informationen vorhanden. Diese werden nun umgerechnet
	if (isset ($exif[GPSLongitude][0])) 
			{
						
				//Die Werte muessen erst berechnet werden. Zuerst für die Laengenangaben
				// einmal.
				$gps_laenge_1 = explode("/",$exif[GPSLongitude][0]);
				if (isset($gps_laenge_1[1])) {$gps_laenge_1 = ($gps_laenge_1[0] / $gps_laenge_1[1]);} else {$gps_laenge_1 = $gps_laenge_1[0] ;}
				
				// zweimal.
				$gps_laenge_2 = explode("/",$exif[GPSLongitude][1]);
				if (isset($gps_laenge_2[1])) {$gps_laenge_2 = ($gps_laenge_2[0] / $gps_laenge_2[1]);} else {$gps_laenge_2 = $gps_laenge_2[0] ;}
				
				// dreimal... hier mit Runden und Auffuellen der Nullen
				$gps_laenge_3 = explode("/",$exif[GPSLongitude][2]);
				if (isset($gps_laenge_3[1])) {$gps_laenge_3 = ($gps_laenge_3[0] / $gps_laenge_3[1]);} else {$gps_laenge_3 = $gps_laenge_3[0] ;}
				$gps_laenge_3 = round ($gps_laenge_3, 2);
				$gps_laenge_3 = str_pad($gps_laenge_3, 5 ,'0', STR_PAD_RIGHT);
				
				$gps_laenge = ($gps_laenge_1)."&deg;".($gps_laenge_2)."'".($gps_laenge_3).'"';
				
				// Umrechung in das Gradformat
				
				$gps_laenge_format = $gps_laenge;
				$gps_laenge = (((($gps_laenge_3 / 60) + $gps_laenge_2) / 60) + $gps_laenge_1);
				
				//Die Werte muessen erst berechnet werden. Nun fuer die Breitenangaben
				
				// einmal.
				$gps_breite_1 = explode("/",$exif[GPSLatitude][0]);
				if (isset($gps_breite_1[1])) {$gps_breite_1 = ($gps_breite_1[0] / $gps_breite_1[1]);} else {$gps_breite_1 = $gps_breite_1[0] ;}
				
				// zweimal.
				$gps_breite_2 = explode("/",$exif[GPSLatitude][1]);
				if (isset($gps_breite_2[1])) {$gps_breite_2 = ($gps_breite_2[0] / $gps_breite_2[1]);} else {$gps_breite_2 = $gps_breite_2[0] ;}
				
				// dreimal... hier mit Runden und Auffuellen der Nullen
				$gps_breite_3 = explode("/",$exif[GPSLatitude][2]);
				if (isset($gps_breite_3[1])) {$gps_breite_3 = ($gps_breite_3[0] / $gps_breite_3[1]);} else {$gps_breite_3 = $gps_breite_3[0] ;}
				$gps_breite_3 = round ($gps_breite_3, 2);
				$gps_breite_3 = str_pad($gps_breite_3, 5 ,'0', STR_PAD_RIGHT);
				
				$gps_breite = ($gps_breite_1)."&deg;".($gps_breite_2)."'".($gps_breite_3).'"';
				
				// Umrechung in das Gradformat
				
				$gps_breite_format = $gps_breite;
				$gps_breite = (((($gps_breite_3 / 60) + $gps_breite_2) / 60) + $gps_breite_1);
				
				// Unterscheidung in Nord und Sued und West und Ost.
				if ($exif[GPSLatitudeRef] == "S") {$gps_breite = "-$gps_breite"; $gps_breite_format = "S $gps_breite_format";} else {$gps_breite_format = "N $gps_breite_format";}
				if ($exif[GPSLongitudeRef] == "W") {$gps_laenge = "-$gps_laenge"; $gps_laenge_format = "W $gps_laenge_format";} else {$gps_laenge_format = "O $gps_laenge_format";}
				
				
				// Die GPS Daten sind berechnet. Nun wird ein neuer Array geschaffen, der alle Informationen zu den Gallerien mit Koordinaten plus die jeweiligen Koordinaten enthält
				if (!isset ($control_geo_data)) {$control_geo_data = 0;}
			
				$worldmap_data_geo[$control_geo_data] = $data;
				$worldmap_data_geo[$control_geo_data][geo] = $gps_breite.",".$gps_laenge;
				$worldmap_data_geo[$control_geo_data][geoformat] = 'Breite: '.$gps_breite_format.'<br> L&auml;nge: '.$gps_laenge_format;
				$control_geo_data++;
				
				
				
			}
		
		
}

// Nun können die anderen Daten wieder gelöscht werden
unset ($worldmap_data);

// Die Daten sind gesammelt, nun wird die Karte erstellt.
// Falls die Schleife zum ersten Mal durchläuft, muss erst die Karte erstellt werden und der div Container eingefügt werden
		if (!isset($ngg_geo_init))
		{
			$ngg_geo_init = 1;
			$ngg_geo_return = '<div id="ngg_geo_map" class="ngg_geo_map" '.$ngg_geo_map_style.'></div>
			<script type="text/javascript">
					 var map = null;
					 
					 function nggGeoMap()
					 {
						map = new VEMap("ngg_geo_map");
						map.SetCredentials("Your Bing Maps Key");
						map.HideDashboard();
						map.LoadMap();
						map.SetMapStyle(VEMapStyle.'.get_option("ngg_geo_map_type").');
						var locs = [];
	
			';	
		}


// Beginn der Schleife
$control = 0;
foreach ($worldmap_data_geo as $data) 
	{
		$picture_thumbs_url = get_bloginfo(wpurl)."/".$data[path]."/thumbs/thumbs_".$data[filename];
		$map_description = '<img src="'.$picture_thumbs_url.'" alt="Foto" /><br><br>'.$data[galdesc].'<br><br><a style="color:#000; text-decoration: none;" href="'.get_bloginfo(wpurl).'/?page_id='.get_option("ngg_geo_worldmap_page").'&album=1&gallery='.$data[gid].'" title="'.__('more photos', 'nextgen-gallery-geo').'" target="_self">'.__('more photos', 'nextgen-gallery-geo').'</a>';
		
		$ngg_geo_return .= 

			'var loc_'.$control.' = new VELatLong('.$data[geo].');
			var pin_'.$control.' = new VEPushpin('.$control.', loc_'.$control.', null, "'.$data[title].'", \''.$map_description.'\');            
			map.AddPushpin(pin_'.$control.');
			locs.push(loc_'.$control.');
			';
			
			
			
			++$control;
	
	}

// Die Karte wird fokussiert und geschlossen
$ngg_geo_return .= 'map.SetMapView(locs);  } </script><script type="text/javascript"> nggGeoMap(); </script>';

echo $ngg_geo_return;

}

?>